# SoReplacedElement Class Reference
[Elements (mostly for internal use)]

`#include <Inventor/elements/SoReplacedElement.h>`

Inheritance diagram for SoReplacedElement:

List of all members.

## Detailed Description

The SoReplacedElement class is an abstract element superclass.

This is the superclass of all elements where the new element value replaces the old value. Most elements in the Coin library is in this category.

Apart from this conceptual difference from it's superclass, the SoReplacedElement class also overloads the default getElement() method to include a node reference. This reference is used to fetch the unique node identification number of the node that last changed the element.

The identifier values of nodes in the scenegraph is updated upon any kind of change to a node, so this technique plays an important role in the construction, validation and destruction of internal scenegraph caches.

See also:
  SoAccumulatedElement

## Public Member Functions

virtual void | init (SoState *state)
virtual SbBool | matches (const SoElement *element) const
virtual SoElement * | copyMatchInfo () const
uint32_t | getNodeId () const
virtual void | print (FILE *file) const

## Static Public Member Functions

void | initClass (void)

## Protected Member Functions

virtual | ~SoReplacedElement ()

## Static Protected Member Functions

SoElement * | getElement (SoState *const state, const int stackIndex, SoNode *const node)

## Protected Attributes

uint32_t | nodeId

## Constructor & Destructor Documentation

SoReplacedElement::~SoReplacedElement | ( | void |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoReplacedElement::initClass | ( | void |  | ) | `[static]`

| Initialize relevant common data for all instances, like the type system. Reimplemented from SoElement. Reimplemented in SoGLColorIndexElement, SoListenerPositionElement, SoListenerOrientationElement, and SoListenerDopplerElement.

void SoReplacedElement::init | ( | SoState * | state | ) | `[virtual]`

| This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects. Reimplemented from SoElement. Reimplemented in SoGLColorIndexElement, SoListenerPositionElement, SoListenerOrientationElement, and SoListenerDopplerElement.

SbBool SoReplacedElement::matches | ( | const SoElement * | element | ) | const`[virtual]`

| This function returns `TRUE` is the element matches another element (of the same class), with respect to cache validity. If the application programmer's extension element has a matches() function, it should also have a copyMatchInfo() function. Implements SoElement.

SoElement * SoReplacedElement::copyMatchInfo | ( | void |  | ) | const`[virtual]`

| This function creates a copy of the element that contains enough information to enable the matches() function to work. Used to help with scenegraph traversal caching operations. Implements SoElement.

uint32_t SoReplacedElement::getNodeId | ( | void |  | ) | const

| Returns the node identifier for the node that previously updated the SoReplacedElement.

void SoReplacedElement::print | ( | FILE * | file | ) | const`[virtual]`

| This function is for printing element information, and is used mostly for debugging purposes. Reimplemented from SoElement. Reimplemented in SoListenerPositionElement, SoListenerOrientationElement, and SoListenerDopplerElement.

SoElement * SoReplacedElement::getElement | ( | SoState *const | state,
|  | const int | stackIndex,
|  | SoNode *const | node
| ) | `[static, protected]`

This function overloads SoElement::getElement() with an extra node parameter, to let us set the SoReplacedElement::nodeId in the element instance before returning.

SoReplacedElement subclasses should use this method to get writable instances.

The identifier values of nodes in the scenegraph is updated upon any kind of change to a node, so this technique plays an important role in the construction, validation and destruction of internal scenegraph caches.

See also:
  SoElement::getElement()

## Member Data Documentation

uint32_t SoReplacedElement::nodeId`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoReplacedElement.h
- SoReplacedElement.cpp